﻿using Quartz;
using System.Net.Http.Json;
using Console = System.Console;

namespace Scheduler.ScheduleModule
{
    public class BaseHttpRequestJob : IJob, IDisposable
    {
        private readonly IHttpClientFactory _clientFactory;

        public BaseHttpRequestJob(IHttpClientFactory clientFactory)
        {
            _clientFactory = clientFactory;
        }

        public static readonly JobKey Key = new JobKey(nameof(BaseHttpRequestJob), "group of HttpRequestJob");

        public async Task Execute(IJobExecutionContext context)
        {
            var reqString = context.MergedJobDataMap.GetString("job");
            if (reqString == null) return;
            var job = System.Text.Json.JsonSerializer.Deserialize<AppJob>(reqString);
            if (job == null) return;
            Console.WriteLine($"{job.Id}, {job.Name}");

            var httpClient = _clientFactory.CreateClient();
            await httpClient.PostAsync(job.Path, null, context.CancellationToken);
        }

        /// <summary>Performs application-defined tasks associated with freeing, releasing, or resetting unmanaged resources.</summary>
        public void Dispose()
        {
            
        }
    }
}
